<?php session_start(); ?>
<?php
define("DEFAULT_LOCALE", "euc-kr");
setlocale(LC_ALL, DEFAULT_LOCALE);
?>
<?php /* no security */ ?>
<?php
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Date in the past
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // always modified
header("Cache-Control: no-store, no-cache, must-revalidate"); // HTTP/1.1
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache"); // HTTP/1.0
?>
<?php include ("db.php") ?>
<?php include ("function.php") ?>
<?php 
$displayRecs = 20;
$recRange = 10;

// Get table name
$tablename = "`tables_priv`";
$dbwhere = "";
$a_search = "";
$b_search = "";
?>
<?php 
// Get search criteria for basic search
$pSearch = @$HTTP_GET_VARS["psearch"];
if ($pSearch != "")
{
	$pSearch = (!get_magic_quotes_gpc()) ? addslashes($pSearch) : $pSearch;
	$b_search .= "`Host` LIKE '%".$pSearch."%' OR ";
	$b_search .= "`Db` LIKE '%".$pSearch."%' OR ";
	$b_search .= "`User` LIKE '%".$pSearch."%' OR ";
	$b_search .= "`Table_name` LIKE '%".$pSearch."%' OR ";
	$b_search .= "`Grantor` LIKE '%".$pSearch."%' OR ";
	$b_search .= "`Table_priv` LIKE '%".$pSearch."%' OR ";
	$b_search .= "`Column_priv` LIKE '%".$pSearch."%' OR ";
} 
if (strlen($b_search) > 4)
{
	$b_search = substr($b_search, 0, strlen($b_search)-4);
	$b_search = "(".$b_search.")";
} 
?>
<?php 
//Build search criteria
if ($a_search != "")
{
	$dbwhere .= $a_search; //advance search
} elseif ($b_search!="") {
	$dbwhere .= $b_search; //basic search
}

//Save search criteria
if ($dbwhere != "")
{
   	$HTTP_SESSION_VARS["tablename"] = $tablename;
    $HTTP_SESSION_VARS["dbwhere"] = $dbwhere;
	//reset start record counter
    $startRec = 1;
    $HTTP_SESSION_VARS["tables_priv_REC"] = $startRec;
} else {
    if ($tablename == @$HTTP_SESSION_VARS["tablename"])
    {
		$dbwhere = $HTTP_SESSION_VARS["dbwhere"];
    } else {
		//reset search criteria
      	$dbwhere = "";
      	$HTTP_SESSION_VARS["dbwhere"] = $dbwhere;
    } 
} 

//Get clear search cmd
$cmd = @$HTTP_GET_VARS["cmd"];
if (strtoupper($cmd)=="RESET")
{
	//reset search criteria
	 $dbwhere = "";
	 $HTTP_SESSION_VARS["dbwhere"] = $dbwhere;
} 
?>
<?php 
// Load Default Order
$DefaultOrder = "";
$DefaultOrderType = "";

// Check for an Order parameter
$OrderBy = @$HTTP_GET_VARS["order"];

if ($OrderBy != "")
{	
	// Check if an ASC/DESC toggle is required
	if ($HTTP_SESSION_VARS["tables_priv_OB"] == $OrderBy)
	{	
		if ($HTTP_SESSION_VARS["tables_priv_OT"] == "ASC")
		{		
			$HTTP_SESSION_VARS["tables_priv_OT"] = "DESC";
		} else {
			$HTTP_SESSION_VARS["tables_priv_OT"] = "ASC";
		} 
	} else {
		$HTTP_SESSION_VARS["tables_priv_OT"] = "ASC";
	}
	$HTTP_SESSION_VARS["tables_priv_OB"] = $OrderBy;
	$HTTP_SESSION_VARS["tables_priv_REC"] = 1;
} else {	
	$OrderBy = @$HTTP_SESSION_VARS["tables_priv_OB"];
	if ($OrderBy == "")
	{
		$OrderBy = $DefaultOrder;
		$HTTP_SESSION_VARS["tables_priv_OB"] = $OrderBy;
		$HTTP_SESSION_VARS["tables_priv_OT"] = $DefaultOrderType;
	}
} 

// Check for a START parameter
$startRec = @$HTTP_GET_VARS["start"];

if ($startRec != "")
{
	$HTTP_SESSION_VARS["tables_priv_REC"] = $startRec;
} else {
	$startRec = @$HTTP_SESSION_VARS["tables_priv_REC"];
	if ($startRec == "")
	{
		//reset start record counter
	  	$startRec = 1;
	  	$HTTP_SESSION_VARS["tables_priv_REC"] = $startRec;
	}
} 

//Set the last record to display
$stopRec = $startRec + $displayRecs - 1;

// Open Connection to the database
$conn = mysql_connect(HOST, USER, PASS);
mysql_select_db(DB);

// Build Query
$strsql = "SELECT * FROM `tables_priv`";

if ($dbwhere != "")
{
	$strsql .= " WHERE ".$dbwhere;
} 

if ($OrderBy != "")
{
	$strsql .= " ORDER BY `".$OrderBy."` ".@$HTTP_SESSION_VARS["tables_priv_OT"];
} 

$rs = mysql_query($strsql, $conn) or die(mysql_error());

$totalRecs = mysql_num_rows($rs);
?>
<?php include ("header.php") ?>
</span><p><span style="font-size:9pt;">TABLE: tables priv</span></p>

<form action="tables_privlist.php">
<table border="0" cellspacing="1" cellpadding="4">
	<tr>		
		<td><span style="font-size:9pt;"> ̽ ˻</span></td>
		<td>
		<span style="font-size:9pt;"><input type="Text" name="psearch" size=10>
		<input type="Submit" name="Submit" value="GO!"></span>
		</td>
		<td><a href="tables_privlist.php?cmd=reset"><span style="font-size:9pt;"> 
                ̱</span></a></td>
	</tr>
</table>
</form>


</span><form>
<table border="0" cellspacing="1" cellpadding="5" bgcolor="#CCCCCC">
<tr bgcolor="#0099CC">
<td>
<a href="tables_privlist.php?order=<?php echo urlencode("Host"); ?>"><font color="#FFFFFF"><span style="font-size:9pt;">Host&nbsp;(*)</span></font></a>
</td>
<td>
<a href="tables_privlist.php?order=<?php echo urlencode("Db"); ?>"><font color="#FFFFFF"><span style="font-size:9pt;">Db&nbsp;(*)</span></font></a>
</td>
<td>
<a href="tables_privlist.php?order=<?php echo urlencode("User"); ?>"><font color="#FFFFFF"><span style="font-size:9pt;">User&nbsp;(*)</span></font></a>
</td>
<td>
<a href="tables_privlist.php?order=<?php echo urlencode("Table_name"); ?>"><font color="#FFFFFF"><span style="font-size:9pt;">Table name&nbsp;(*)</span></font></a>
</td>
<td>
<a href="tables_privlist.php?order=<?php echo urlencode("Grantor"); ?>"><font color="#FFFFFF"><span style="font-size:9pt;">Grantor&nbsp;(*)</span></font></a>
</td>
<td>
<a href="tables_privlist.php?order=<?php echo urlencode("Timestamp"); ?>"><font color="#FFFFFF"><span style="font-size:9pt;">Timestamp&nbsp;</span></font></a>
</td>
<td>
<a href="tables_privlist.php?order=<?php echo urlencode("Table_priv"); ?>"><font color="#FFFFFF"><span style="font-size:9pt;">Table priv&nbsp;(*)</span></font></a>
</td>
<td>
<a href="tables_privlist.php?order=<?php echo urlencode("Column_priv"); ?>"><font color="#FFFFFF"><span style="font-size:9pt;">Column priv&nbsp;(*)</span></font></a>
</td>

</tr>
<?php
$recCount = $startRec - 1;
@mysql_data_seek($rs, $recCount);
while (($row = mysql_fetch_assoc($rs)) && ($recCount < $stopRec))
{
	$recCount++;
	if (intval($recCount) >= intval($startRec))
    {
		//set row color
		$bgcolor="#FFFFFF";
?>
<?php 
		// Display alternate color for rows
		if ($recCount % 2 != 0)
		{
			$bgcolor = "#F5F5F5";
		} 
?>
<?php 
$x_Host = $row["Host"];
$x_Db = $row["Db"];
$x_User = $row["User"];
$x_Table_name = $row["Table_name"];
$x_Grantor = $row["Grantor"];
$x_Timestamp = $row["Timestamp"];
$x_Table_priv = $row["Table_priv"];
$x_Column_priv = $row["Column_priv"];
?>
<tr bgcolor="<?php echo $bgcolor; ?>">
<td>
                <span style="font-size:9pt;"><?php echo $x_Host ?>&nbsp;
                </span></td>
<td>
                <span style="font-size:9pt;"><?php echo $x_Db ?>&nbsp;
                </span></td>
<td>
                <span style="font-size:9pt;"><?php echo $x_User ?>&nbsp;
                </span></td>
<td>
                <span style="font-size:9pt;"><?php echo $x_Table_name ?>&nbsp;
                </span></td>
<td>
                <span style="font-size:9pt;"><?php echo $x_Grantor ?>&nbsp;
                </span></td>
<td>
                <span style="font-size:9pt;"><?php echo $x_Timestamp ?>&nbsp;
                </span></td>
<td>
                <span style="font-size:9pt;"><?php echo $x_Table_priv ?>&nbsp;
                </span></td>
<td>
                <span style="font-size:9pt;"><?php echo $x_Column_priv ?>&nbsp;
                </span></td>
</tr>
<?php
	}
}

mysql_free_result($rs);
mysql_close($conn);
?>
</table>
</form>
<span style="font-size:9pt;">
<?php 
if ($totalRecs > 0)
{
	// Find out if there should be Backward or Forward Buttons on the table.
	if ($startRec == 1)
	{
		 $isPrev = false;
	} else	{	
		$isPrev = true;
		$PrevStart = $startRec - $displayRecs;
		if ($PrevStart < 1)
		{
			$PrevStart = 1;
		}
?>
	<hr size="1" noshade>
	<strong><a href="tables_privlist.php?start=<?php echo $PrevStart; ?>"><font size="-1">[&lt;&lt;&nbsp;Prev]</font></a></strong>
<?php 
	}

	// Display Page numbers
    if ($isPrev||(!($totalRecs == 0)))
    {
      	if (!$isPrev)
      	{
?>
	<hr size="1" noshade>
<?php
		}

		$x = 1;
      	$y = 1;

      	$dx1 = intval(($startRec - 1)/($displayRecs*$recRange))*$displayRecs*$recRange + 1;
     	$dy1 = intval(($startRec - 1)/($displayRecs*$recRange))*$recRange + 1;
      	if (($dx1 + $displayRecs*$recRange - 1) > $totalRecs)
		{		
			$dx2 = intval($totalRecs/$displayRecs)*$displayRecs + 1;
			$dy2 = intval($totalRecs/$displayRecs) + 1;
		} else {
			$dx2 = $dx1 + $displayRecs*$recRange - 1;
		  	$dy2 = $dy1 + $recRange - 1;
		} 


		while ($x <= $totalRecs)
      	{
			if (($x >= $dx1)&&($x <= $dx2))
        	{
          		if (intval($startRec) == intval($x))
          		{
?>
	<strong><font size="-1"><?php echo $y; ?></font></strong>
<?php
				} else {
?>
	<strong><a href="tables_privlist.php?start=<?php echo $x; ?>"><font size="-1"><?php echo $y; ?></font></a></strong>
<?php
				} 
         		$x = $x + $displayRecs;
          		$y = $y + 1;
        	} elseif (($x >= ($dx1 - $displayRecs*$recRange))&&($x <= ($dx2 + $displayRecs*$recRange)))
        	{

	          	if ($x + $recRange*$displayRecs < $totalRecs)
	          	{
?>
		<strong><a href="tables_privlist.php?start=<?php echo $x; ?>"><font size="-1"><?php echo $y; ?>-<?php echo $y + $recRange - 1; ?></font></a></strong>
<?php
				} else {
		            $ny = intval(($totalRecs - 1)/$displayRecs) + 1;
					if ($ny == $y)
		            {
	?>
		<strong><a href="tables_privlist.php?start=<?php echo $x; ?>"><font size="-1"><?php echo $y; ?></font></a></strong>
	<?php
					} else {
	?>
		<strong><a href="tables_privlist.php?start=<?php echo $x; ?>"><font size="-1"><?php echo $y; ?>-<?php echo $ny; ?></font></a></strong>
	<?php
					} 
				}	
	          	$x = $x + $recRange*$displayRecs;
	          	$y = $y + $recRange;
	        } else {
	          	$x = $x + $recRange*$displayRecs;
	          	$y = $y + $recRange;
	        } 
		} 
	} 

	// Next link
    if ($totalRecs >= $startRec + $displayRecs)
    {
		$NextStart = $startRec + $displayRecs;
		$isMore = true;
 ?>
	<strong><a href="tables_privlist.php?start=<?php echo $NextStart; ?>"><font size="-1">[Next&nbsp;&gt;&gt;]</font></a></strong>
<?php
	} else {
		$isMore=false;
    }
 ?>
	<hr size="1" noshade>
<?php
	if ($stopRec > $recCount)
    {
    $stopRec = $recCount;
	}
 ?>
	<font size="-1">Records <?php echo $startRec; ?> to <?php echo $stopRec; ?> of <?php echo $totalRecs; ?></font>
<?php
} else {
?>
<br><br>
<font size="-1">No records found!</font>
<br><br>
<?php
}
?>
<?php include ("footer.php") ?>
